/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Cliente;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCliente;


@Controller("busquedaClienteController")
@Scope("prototype")
public class BusquedaClienteController extends MyGenericForwardComposer {

	@Autowired
	private transient PagedListWrapper<Cliente> plwCliente;
    private MyListbox clienteList;
    private Paging pagingCliente;
    private MyTextbox txtNombCliente;
    private MyTextbox txtApelidoPaterno;
    private MyTextbox txtApelidoMaterno;
    private Textbox txtTelefonoUno;
    private Textbox txtTelefonoDos;
    private Radio radFeminino;
    private Radio radMasculino;




    public Textbox getTxtTelefonoUno() {
		return txtTelefonoUno;
	}

	public void setTxtTelefonoUno(MyTextbox txtTelefonoUno) {
		this.txtTelefonoUno = txtTelefonoUno;
	}

	public Textbox getTxtTelefonoDos() {
		return txtTelefonoDos;
	}

	public void setTxtTelefonoDos(MyTextbox txtTelefonoDos) {
		this.txtTelefonoDos = txtTelefonoDos;
	}

	public MyTextbox getTxtNombCliente() {
		return txtNombCliente;
	}

	public void setTxtNombCliente(MyTextbox txtNombCliente) {
		this.txtNombCliente = txtNombCliente;
	}

	public MyTextbox getTxtApelidoPaterno() {
		return txtApelidoPaterno;
	}

	public void setTxtApelidoPaterno(MyTextbox txtApelidoPaterno) {
		this.txtApelidoPaterno = txtApelidoPaterno;
	}

	public MyTextbox getTxtApelidoMaterno() {
		return txtApelidoMaterno;
	}

	public void setTxtApelidoMaterno(MyTextbox txtApelidoMaterno) {
		this.txtApelidoMaterno = txtApelidoMaterno;
	}

	public MyListbox getClienteoList() {
        return clienteList;
    }

    public void setClienteList(MyListbox clienteList) {
        this.clienteList = clienteList;
    }



    public PagedListWrapper<Cliente> getPlwCliente() {
		return plwCliente;
	}

	public void setPlwCliente(PagedListWrapper<Cliente> plwCliente) {
		this.plwCliente = plwCliente;
	}

	@Override
    public void doAfterCompose(Component comp) throws Exception {
       

        super.doAfterCompose(comp);

        clienteList.setItemRenderer(new RenderCliente());
        clienteList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Cliente c = (Cliente) clienteList.getSelected();
                verCliente(c);
            }
        });
      
       refreshLista();

    }

    private void verCliente(Cliente c) {
		if (c == null) {
			return;
		}

		Map args = new HashMap();
		args.put("cliente", c);
		args.put("clienteList", clienteList);

		openWindow("/gui/senda_amigo/editarCliente.zul",
				Labels.getLabel("editarClienteController.window.title"), args, MODAL);
	}

    private void refreshLista() {
        HibernateSearchObject<Cliente> sistemaBusqueda =
                new HibernateSearchObject<Cliente>(Cliente.class,
                		pagingCliente.getPageSize());

        String nombcliente = txtNombCliente.getText();
        if (nombcliente != null) {
            sistemaBusqueda.addFilterLike("nombcliente", "%" + nombcliente.trim().concat("%"));
        }

        String apellidopaterno = txtApelidoPaterno.getText();
        if (apellidopaterno != null) {
            sistemaBusqueda.addFilterLike("apellidopaterno", "%" + apellidopaterno.trim().concat("%"));
        }

        String apellidomaterno = txtApelidoMaterno.getText();
        if (apellidomaterno != null) {
            sistemaBusqueda.addFilterLike("apellidomaterno", "%" + apellidomaterno.trim().concat("%"));
        }
        
//        String numtelefono = txtTelefonoUno.getText();
//        if (numtelefono != null) {
//            sistemaBusqueda.addFilterLike("numtelefono", "%" + numtelefono.trim().concat("%"));
//        }
//        
//        String numtelefonodos = txtTelefonoDos.getText();
//        if (numtelefonodos != null) {
//            sistemaBusqueda.addFilterLike("numtelefonodos", "%" + numtelefonodos.trim().concat("%"));
//        }

        sistemaBusqueda.addFilterEqual("activo", Boolean.TRUE);
        sistemaBusqueda.addSortAsc("nombcliente");        
        sistemaBusqueda.addFilterNotEqual("clienteId", -1);

        plwCliente.init(sistemaBusqueda, clienteList, pagingCliente);

        if (clienteList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaClienteController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verCliente(new Cliente());
    }
}
